/*
 * BatchProcessPanel.java
 *
 * Copyright (C) 2012 Christian Mayer
 *
 * This file is part of CellXGui
 *
*/

/*
 * BatchProcessPanel.java
 *
 * Created on Jan 30, 2012, 4:25:01 PM
 */
package cellxgui.view;

import cellxgui.controller.CellXController;
import cellxgui.controller.filehandling.CellXFluoFile;
import cellxgui.controller.filehandling.CellXTimeSeries;
import cellxgui.view.dialogs.wizard.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeEvent;
import java.io.File;
import java.util.List;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;
import javax.swing.AbstractListModel;
import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JTextField;
import javax.swing.ListModel;
import javax.swing.SwingUtilities;

/**
 *
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
public class BatchProcessPanel extends javax.swing.JPanel implements AbstractView {

    private File getImageDir() {
        if (!imgDirTF.getText().trim().isEmpty()) {
            final File f = new File(imgDirTF.getText());
            if (f.exists()) {
                return f;
            }
        }
        return control.getProperties().getImageDir();
    }

    private enum CheckValue {

        VALID_PATTERN,
        EMPTY_PATTERN,
        REVERT_PATTERN,
        EDIT_PATTERN;
    }

    private enum DirCheckValue {

        EMPTY_FILENAME,
        CONTAINS_NO_FILES,
        IS_NO_DIRECTORY,
        DOES_NOT_EXIST,
        VALID_DIR,
        NOT_READABLE,
        NOT_WRITABLE;
    }
    private final CellXController control;

    /**
     * Creates new form BatchProcessPanel
     */
    public BatchProcessPanel(CellXController control) {
        initComponents();
        this.control = control;
        initFluoPatternListListener();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        oofRegExpTF = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        fluoTypeRegexpListView = new javax.swing.JList();
        addFluoTypeBtn = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        frameIdxRegexpTF = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        imgDirTF = new javax.swing.JTextField();
        openDirBtn = new javax.swing.JButton();
        previewFileSetsBtn = new javax.swing.JButton();
        runBtn = new javax.swing.JButton();
        cellTrackingCheckBox = new javax.swing.JCheckBox();
        jScrollPane2 = new javax.swing.JScrollPane();
        fileSetClassesList = new javax.swing.JList();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        ffRegexpTF = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        resultsDirTF = new javax.swing.JTextField();
        openDirBtn1 = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        oofWizardBtn = new javax.swing.JButton();
        frameWizardBtn = new javax.swing.JButton();
        fluoTypeWizardBtn = new javax.swing.JButton();
        flatFieldWizardBtn = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(1100, 600));

        jLabel1.setText("Segmentation Images Regular Expression");

        oofRegExpTF.setToolTipText("A regular expression to identify out of focus image filenames");
        oofRegExpTF.setPreferredSize(new java.awt.Dimension(200, 28));
        oofRegExpTF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                oofRegExpTFActionPerformed(evt);
            }
        });

        jLabel2.setText("Quantification Images Regular Expression(s)");

        jScrollPane1.setPreferredSize(new java.awt.Dimension(500, 131));

        fluoTypeRegexpListView.setToolTipText("Regular expression(s) to extract the fluorescence type from image filenames");
        jScrollPane1.setViewportView(fluoTypeRegexpListView);

        addFluoTypeBtn.setText("Add");
        addFluoTypeBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addFluoTypeBtnActionPerformed(evt);
            }
        });

        jLabel3.setText("Frame Number Regular Expression");

        frameIdxRegexpTF.setToolTipText("The regular expression to extract the frame index from image filenames");
        frameIdxRegexpTF.setPreferredSize(new java.awt.Dimension(200, 28));
        frameIdxRegexpTF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                frameIdxRegexpTFActionPerformed(evt);
            }
        });

        jLabel5.setText("Image Directory");

        imgDirTF.setToolTipText("The directory that contains the images for analysis (optionally with subfolders each containing one time series) ");
        imgDirTF.setPreferredSize(new java.awt.Dimension(500, 28));

        openDirBtn.setText("Select");
        openDirBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openDirBtnActionPerformed(evt);
            }
        });

        previewFileSetsBtn.setText("Generate File Series");
        previewFileSetsBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previewFileSetsBtnActionPerformed(evt);
            }
        });

        runBtn.setText("Run CellX");
        runBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runBtnActionPerformed(evt);
            }
        });

        cellTrackingCheckBox.setSelected(true);
        cellTrackingCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cellTrackingCheckBoxActionPerformed(evt);
            }
        });

        jScrollPane2.setViewportView(fileSetClassesList);

        jLabel6.setText("Flat Field Images Regular Expression ");

        jLabel7.setText("Do Cell Tracking");

        ffRegexpTF.setToolTipText("A regular expression to identify flat field image filenames");
        ffRegexpTF.setPreferredSize(new java.awt.Dimension(500, 28));
        ffRegexpTF.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ffRegexpTFActionPerformed(evt);
            }
        });

        jLabel9.setText("Result Directory");

        resultsDirTF.setToolTipText("The directory for the result files");
        resultsDirTF.setPreferredSize(new java.awt.Dimension(500, 28));

        openDirBtn1.setText("Select");
        openDirBtn1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openDirBtn1ActionPerformed(evt);
            }
        });

        oofWizardBtn.setText("Wizard");
        oofWizardBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                oofWizardBtnActionPerformed(evt);
            }
        });

        frameWizardBtn.setText("Wizard");
        frameWizardBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                frameWizardBtnActionPerformed(evt);
            }
        });

        fluoTypeWizardBtn.setText("Wizard");
        fluoTypeWizardBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fluoTypeWizardBtnActionPerformed(evt);
            }
        });

        flatFieldWizardBtn.setText("Wizard");
        flatFieldWizardBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                flatFieldWizardBtnActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 1076, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 627, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(runBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel6)
                            .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(40, 40, 40)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(imgDirTF, javax.swing.GroupLayout.PREFERRED_SIZE, 396, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(openDirBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(addFluoTypeBtn)
                                    .addComponent(fluoTypeWizardBtn)))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(oofRegExpTF, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(oofWizardBtn))
                            .addComponent(cellTrackingCheckBox, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(frameIdxRegexpTF, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(frameWizardBtn))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(ffRegexpTF, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(flatFieldWizardBtn))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(resultsDirTF, javax.swing.GroupLayout.PREFERRED_SIZE, 396, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(openDirBtn1, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(previewFileSetsBtn))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(51, 51, 51)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(openDirBtn)
                    .addComponent(imgDirTF, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(oofWizardBtn)
                    .addComponent(oofRegExpTF, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(frameIdxRegexpTF, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(frameWizardBtn))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(fluoTypeWizardBtn))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(addFluoTypeBtn))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel6)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(ffRegexpTF, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(flatFieldWizardBtn)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(cellTrackingCheckBox, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(resultsDirTF, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(openDirBtn1))
                    .addComponent(jLabel9))
                .addGap(52, 52, 52)
                .addComponent(previewFileSetsBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                        .addGap(27, 27, 27))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(runBtn, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void addFluoTypeBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addFluoTypeBtnActionPerformed
        CheckValue ret = CheckValue.EDIT_PATTERN;
        String value = "";
        while (ret == CheckValue.EDIT_PATTERN) {
            value = JOptionPane.showInputDialog(this, "Enter regular expression for fluorescence image filename", value);
            if (value == null) {
                return;
            }
            ret = checkRegexp(value, true, "fluorescence image");
            if (ret == CheckValue.VALID_PATTERN) {
                control.addFluoTypePattern(Pattern.compile(value));
            } else if (ret != CheckValue.EDIT_PATTERN) {
                break;
            }
        }
    }//GEN-LAST:event_addFluoTypeBtnActionPerformed

    private void oofRegExpTFActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_oofRegExpTFActionPerformed
        if (oofChanged()) {
            addFluoTypeBtn.requestFocus();
        }
    }//GEN-LAST:event_oofRegExpTFActionPerformed

    private void runBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runBtnActionPerformed
        if (fileSetClassesList.getModel().getSize() == 0) {
            JOptionPane.showMessageDialog(this, "No file series available", "Info", JOptionPane.INFORMATION_MESSAGE);
            return;
        }

        int selectedIndices[] = fileSetClassesList.getSelectedIndices();
        if (fileSetClassesList.getModel().getSize() == 1) {
            selectedIndices = new int[]{0};
        }

        if (selectedIndices.length == 0) {
            JOptionPane.showMessageDialog(this, "Please select a file series", "Info", JOptionPane.INFORMATION_MESSAGE);
            return;
        }

        DirCheckValue cv = checkDir(resultsDirTF.getText());
        if (cv == DirCheckValue.EMPTY_FILENAME) {
            JOptionPane.showMessageDialog(this, "Please select a directory for result files", "Info", JOptionPane.INFORMATION_MESSAGE);
            return;
        } else if (cv == DirCheckValue.DOES_NOT_EXIST) {
            try {
                final File rd = new File(resultsDirTF.getText());
                rd.mkdirs();
            } catch (SecurityException e) {
                JOptionPane.showMessageDialog(this, "Cannot create result directory '" + resultsDirTF.getText() + "'", "Error", JOptionPane.INFORMATION_MESSAGE);
                return;
            }

        }
        control.runBatch(selectedIndices);
    }//GEN-LAST:event_runBtnActionPerformed

    private void cellTrackingCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cellTrackingCheckBoxActionPerformed
        control.setBatchTrackingEnabled(cellTrackingCheckBox.isSelected());
    }//GEN-LAST:event_cellTrackingCheckBoxActionPerformed

    private void previewFileSetsBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previewFileSetsBtnActionPerformed

        control.resetFileSeries();

        if (allFieldsValid()) {
            control.generateFileSeries();
        }
    }//GEN-LAST:event_previewFileSetsBtnActionPerformed

    private void openDirBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openDirBtnActionPerformed
        final JFileChooser jfc = new JFileChooser();
        jfc.setApproveButtonText("Select");

        jfc.setDialogTitle("Image directory");
        jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        //jfc.setAcceptAllFileFilterUsed(false);

        File f = new File(imgDirTF.getText());
        if (f.exists() && f.isDirectory()) {
            jfc.setCurrentDirectory(f);
        } else {
            f = control.getProperties().getImageDir();
            if (f != null && f.exists()) {
                jfc.setCurrentDirectory(f);
                jfc.setSelectedFile(f);
            }
        }
        final int r = jfc.showOpenDialog(this);
        if (r == JFileChooser.APPROVE_OPTION) {
            control.setBatchImageDirectory(jfc.getSelectedFile());
        }
    }//GEN-LAST:event_openDirBtnActionPerformed

    private void frameIdxRegexpTFActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_frameIdxRegexpTFActionPerformed
        if (framePatternChanged()) {
            addFluoTypeBtn.requestFocus();
        }
    }//GEN-LAST:event_frameIdxRegexpTFActionPerformed

    private void ffRegexpTFActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ffRegexpTFActionPerformed
        if (ffRegexpChanged()) {
            openDirBtn.requestFocus();
        }
    }//GEN-LAST:event_ffRegexpTFActionPerformed

    private void openDirBtn1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openDirBtn1ActionPerformed
        // TODO add your handling code here:
        final JFileChooser jfc = new JFileChooser();
        jfc.setApproveButtonText("Select");

        jfc.setDialogTitle("Result directory");
        jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        //jfc.setAcceptAllFileFilterUsed(false);

        File f = new File(resultsDirTF.getText());
        if (f.exists() && f.isDirectory()) {
            jfc.setCurrentDirectory(f);
        } else {
            f = control.getProperties().getImageDir();
            if (f != null && f.exists()) {
                jfc.setCurrentDirectory(f);
                jfc.setSelectedFile(f);
            }
        }
        
        final int r = jfc.showOpenDialog(this);
        if (r == JFileChooser.APPROVE_OPTION) {
            control.setBatchResultsDirectory(jfc.getSelectedFile());
        }
    }//GEN-LAST:event_openDirBtn1ActionPerformed

    private void oofWizardBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_oofWizardBtnActionPerformed

        final OofWizard w = new OofWizard(control.getView(), getImageDir());
        w.setLocationRelativeTo(control.getView());
        if( w.showWizard()==Wizard.APPROVE_OPTION ){
            control.setOutOfFocusPattern(w.getPattern());
        }
        
    }//GEN-LAST:event_oofWizardBtnActionPerformed

    private void frameWizardBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_frameWizardBtnActionPerformed

        final FrameIndexWizard w = new FrameIndexWizard(control.getView(), getImageDir());
        w.setLocationRelativeTo(control.getView());
        if( w.showWizard()==Wizard.APPROVE_OPTION ){
            control.setFrameIdxPattern(w.getPattern());
        }
        
        
    }//GEN-LAST:event_frameWizardBtnActionPerformed

    private void fluoTypeWizardBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fluoTypeWizardBtnActionPerformed

        final FluoWizard w = new FluoWizard(control.getView(), getImageDir());
        w.setLocationRelativeTo(control.getView());
        if( w.showWizard()==Wizard.APPROVE_OPTION ){
            control.addFluoTypePattern(w.getPattern());
        }
    }//GEN-LAST:event_fluoTypeWizardBtnActionPerformed

    private void flatFieldWizardBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flatFieldWizardBtnActionPerformed
        try {
            final String fluoGroup = control.getBatchModel().getFluorescenceGroup();
            final FlatFieldWizard ffwiz = new FlatFieldWizard(control.getView(), fluoGroup, getImageDir());
            ffwiz.setLocationRelativeTo(control.getView());
            if (Wizard.APPROVE_OPTION == ffwiz.showWizard()) {
                control.setFlatFieldPattern(ffwiz.getRegularExpression());
            }
        } catch (NoGroupInRegexpException e) {
            JOptionPane.showMessageDialog(this, "Cannot find group in pattern: " + e.getPattern());
        } catch(NoFluoPatternsDefined e){
            JOptionPane.showMessageDialog(this, "This requires at least one fluorescence type");
        }
    }//GEN-LAST:event_flatFieldWizardBtnActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addFluoTypeBtn;
    private javax.swing.JCheckBox cellTrackingCheckBox;
    private javax.swing.JTextField ffRegexpTF;
    private javax.swing.JList fileSetClassesList;
    private javax.swing.JButton flatFieldWizardBtn;
    private javax.swing.JList fluoTypeRegexpListView;
    private javax.swing.JButton fluoTypeWizardBtn;
    private javax.swing.JTextField frameIdxRegexpTF;
    private javax.swing.JButton frameWizardBtn;
    private javax.swing.JTextField imgDirTF;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField oofRegExpTF;
    private javax.swing.JButton oofWizardBtn;
    private javax.swing.JButton openDirBtn;
    private javax.swing.JButton openDirBtn1;
    private javax.swing.JButton previewFileSetsBtn;
    private javax.swing.JTextField resultsDirTF;
    private javax.swing.JButton runBtn;
    // End of variables declaration//GEN-END:variables

    @Override
    public void modelPropertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals(CellXController.FILE_SET_PREVIEW)) {
            final List<CellXTimeSeries> contents = (List<CellXTimeSeries>) evt.getNewValue();
            final ListModel m = new AbstractListModel() {

                @Override
                public int getSize() {
                    return contents.size();
                }

                @Override
                public Object getElementAt(int index) {
                    return contents.get(index);
                }
            };
            fileSetClassesList.setModel(m);
        } else if (evt.getPropertyName().equals(CellXController.OOF_PATTERN)) {
            oofRegExpTF.setText((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.FLUO_PATTERNS)) {
            final List<CellXFluoFile> contents = (List<CellXFluoFile>) evt.getNewValue();
            final ListModel m = new AbstractListModel() {

                @Override
                public int getSize() {
                    return contents.size();
                }

                @Override
                public Object getElementAt(int index) {
                    return contents.get(index);
                }
            };
            fluoTypeRegexpListView.setModel(m);
        } else if (evt.getPropertyName().equals(CellXController.FRAME_IDX_PATTERN)) {
            frameIdxRegexpTF.setText((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.DO_CELL_TRACKING)) {
            if ((Boolean) evt.getNewValue()) {
                cellTrackingCheckBox.setSelected(true);
            } else {
                cellTrackingCheckBox.setSelected(false);
            }
        } else if (evt.getPropertyName().equals(CellXController.BATCH_IMAGE_DIR)) {
            imgDirTF.setText((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.FLAT_FIELD_PATTERN)) {
            ffRegexpTF.setText((String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CellXController.BATCH_RESULTS_DIR)) {
            resultsDirTF.setText((String) evt.getNewValue());
        }

    }

    private CheckValue checkRegexp(String value, boolean requiresGroup, String what) {
        if (value.trim().isEmpty()) {
            return CheckValue.EMPTY_PATTERN;
        }
        Pattern p = null;
        try {
            p = Pattern.compile(value);
        } catch (PatternSyntaxException e) {
            Object[] options = {"Edit", "Revert"};
            int answer = JOptionPane.showOptionDialog(
                    SwingUtilities.getWindowAncestor(this),
                    "Regexp syntax error at position " + String.valueOf(e.getIndex()),
                    "Regexp syntax error",
                    JOptionPane.YES_NO_OPTION,
                    JOptionPane.ERROR_MESSAGE,
                    null,
                    options,
                    options[1]);
            if (answer == 1) { //Revert!
                return CheckValue.REVERT_PATTERN;
            } else {
                return CheckValue.EDIT_PATTERN;
            }
        }

        if (requiresGroup) {
            if (!value.matches("(.*?[^\\\\]\\(.*|^\\(.*)")) {
                Object[] options = {"Edit", "Revert"};
                int answer = JOptionPane.showOptionDialog(
                        SwingUtilities.getWindowAncestor(this),
                        "Regular expression for " + what + " must define a group",
                        "Regexp syntax error",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.ERROR_MESSAGE,
                        null,
                        options,
                        options[1]);
                if (answer == 1) { //Revert!
                    return CheckValue.REVERT_PATTERN;
                } else {
                    return CheckValue.EDIT_PATTERN;
                }
            }
        }
        return CheckValue.VALID_PATTERN;
    }

    private DirCheckValue checkDir(String dir) {
        if (dir.trim().isEmpty()) {
            return DirCheckValue.EMPTY_FILENAME;
        }
        final File f = new File(dir.trim());
        if (!f.exists()) {
            return DirCheckValue.DOES_NOT_EXIST;
        }
        if (!f.isDirectory()) {
            return DirCheckValue.IS_NO_DIRECTORY;
        }
        if (!f.canRead()) {
            return DirCheckValue.NOT_READABLE;
        }
        if (!f.canWrite()) {
            return DirCheckValue.NOT_WRITABLE;
        }
        if (f.list().length == 0) {
            return DirCheckValue.CONTAINS_NO_FILES;
        }
        return DirCheckValue.VALID_DIR;
    }

    /**
     *
     * @return false, if the focus should stay where it is for editing
     */
    private boolean oofChanged() {
        final CheckValue ret = checkRegexp(oofRegExpTF.getText(), false, "out of focus image");
        if (ret == CheckValue.VALID_PATTERN) {
            control.setOutOfFocusPattern(Pattern.compile(oofRegExpTF.getText()));
        } else if (ret == CheckValue.REVERT_PATTERN) {
            control.revertOutOfFocusPattern();
        } else if (ret == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            oofRegExpTF.requestFocus();
            return false;
        }
        return true;
    }

    private boolean framePatternChanged() {
        final CheckValue ret = checkRegexp(frameIdxRegexpTF.getText(), true, "frame number");
        if (ret == CheckValue.VALID_PATTERN) {
            control.setFrameIdxPattern(Pattern.compile(frameIdxRegexpTF.getText()));
        } else if (ret == CheckValue.REVERT_PATTERN) {
            control.revertFrameIdxPattern();
        } else if (ret == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            frameIdxRegexpTF.requestFocus();
            return false;
        }
        return true;
    }

    private boolean ffRegexpChanged() {
        final CheckValue ret = checkRegexp(ffRegexpTF.getText(), false, "flat field image");
        if (ret == CheckValue.VALID_PATTERN) {
            control.setFlatFieldPattern(Pattern.compile(ffRegexpTF.getText()));
        } else if (ret == CheckValue.EMPTY_PATTERN) {
            control.setFlatFieldPattern(null);
        } else if (ret == CheckValue.REVERT_PATTERN) {
            control.revertFlatFieldPattern();
        } else if (ret == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            ffRegexpTF.requestFocus();
            return false;
        }
        return true;
    }

    private boolean isImageDirValid() {
        final DirCheckValue check = checkDir(imgDirTF.getText());

        if (check == DirCheckValue.EMPTY_FILENAME) {
            showInfo("Image directory missing", "Missing value");
            imgDirTF.requestFocus();
            return false;
        }
        if (check == DirCheckValue.VALID_DIR) {
            control.setBatchImageDirectory(new File(imgDirTF.getText()));
            return true;
        }

        if (check == DirCheckValue.CONTAINS_NO_FILES) {
            if (askRevertOrEdit("Image directory contains no files")) {
                control.revertBatchImageDir();
            } else {
                control.showBatchPanel();
                imgDirTF.requestFocus();
            }
            return false;
        }


        if (check == DirCheckValue.NOT_READABLE) {
            if (askRevertOrEdit("Image directory not readable")) {
                control.revertBatchImageDir();
            } else {
                control.showBatchPanel();
                imgDirTF.requestFocus();
            }
            return false;
        }

        if (check == DirCheckValue.DOES_NOT_EXIST) {
            if (askRevertOrEdit("Image directory does not exist")) {
                control.revertBatchImageDir();
            } else {
                control.showBatchPanel();
                imgDirTF.requestFocus();
            }
            return false;
        }

        if (check == DirCheckValue.IS_NO_DIRECTORY) {
            if (askRevertOrEdit("Image directory is not a directory")) {
                control.revertBatchImageDir();
            } else {
                control.showBatchPanel();
                imgDirTF.requestFocus();
            }
            return false;
        }

        return true;
    }

    private boolean isResultsDirValid() {
        final DirCheckValue check = checkDir(resultsDirTF.getText());
        if (check == DirCheckValue.EMPTY_FILENAME) {
            JOptionPane.showMessageDialog(this, "Result dir missing");
            return false;
        }
        control.setBatchResultsDirectory(new File(resultsDirTF.getText()));
        return true;
    }

    /**
     *
     * @param what
     * @return true, if the value should be reverted
     */
    private boolean askRevertOrEdit(String what) {
        Object[] options = {"Edit", "Revert"};
        int answer = JOptionPane.showOptionDialog(
                SwingUtilities.getWindowAncestor(this),
                what,
                "Error",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.ERROR_MESSAGE,
                null,
                options,
                options[1]);
        if (answer == 1) { //Revert!
            return true;
        } else {
            return false;
        }
    }

    private void initFluoPatternListListener() {
        fluoTypeRegexpListView.addKeyListener(new KeyAdapter() {

            @Override
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_DELETE || e.getKeyChar() == KeyEvent.VK_BACK_SPACE) {
                    if (!fluoTypeRegexpListView.isSelectionEmpty()) {
                        control.deleteSelectedFluoPatterns(fluoTypeRegexpListView.getSelectedIndices());
                    }
                }
            }
        });

        fluoTypeRegexpListView.addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                if (!fluoTypeRegexpListView.isEnabled()) {
                    return;
                }
                if (e.getButton() == MouseEvent.BUTTON3) {
                    JPopupMenu menue = new JPopupMenu();
                    JMenuItem item = new JMenuItem("Delete");
                    menue.add(item);
                    item.addActionListener(new ActionListener() {

                        @Override
                        public void actionPerformed(ActionEvent e) {
                            control.deleteSelectedFluoPatterns(fluoTypeRegexpListView.getSelectedIndices());
                        }
                    });
                    menue.show(fluoTypeRegexpListView, e.getX(), e.getY());
                }
            }
        });

    }

    public int getIndexOfSelectedFileSeries() {
        return fileSetClassesList.getSelectedIndex();
    }

    public int[] getSelectedIndicesOfFileSeries() {
        return fileSetClassesList.getSelectedIndices();
    }

    private boolean allFieldsValid() {
        //out-of-focus pattern
        CheckValue checkVal = checkRegexp(oofRegExpTF.getText(), false, "out of focus");
        if (checkVal == CheckValue.VALID_PATTERN) {
            control.setOutOfFocusPattern(Pattern.compile(oofRegExpTF.getText()));
        } else if (checkVal == CheckValue.EMPTY_PATTERN) {
            showInfo("Missing out of focus pattern ", "Missing value");
            return false;
        } else if (checkVal == CheckValue.REVERT_PATTERN) {
            control.revertOutOfFocusPattern();
        } else if (checkVal == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            oofRegExpTF.requestFocus();
            return false;
        }



        //fluo patterns are checked when added - nothing to do here
        //frame-pattern
        checkVal = checkRegexp(frameIdxRegexpTF.getText(), true, "frame number");
        if (checkVal == CheckValue.VALID_PATTERN) {
            control.setFrameIdxPattern(Pattern.compile(frameIdxRegexpTF.getText()));
        } else if (checkVal == CheckValue.EMPTY_PATTERN) {
            showInfo("Missing frame number pattern ", "Missing value");
            return false;
        } else if (checkVal == CheckValue.REVERT_PATTERN) {
            control.revertFrameIdxPattern();
        } else if (checkVal == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            frameIdxRegexpTF.requestFocus();
            return false;
        }

        //flat field regexp
        boolean valid = ffRegexpChanged();
        if (!valid) {
            return false;
        }

        if (!isImageDirValid()) {
            return false;
        }
        if (!isResultsDirValid()) {
            return false;
        }


        return true;
    }

    public boolean commitForSave() {
        CheckValue cv = checkRegexp(oofRegExpTF.getText(), false, "out of focus image");
        if (cv == CheckValue.VALID_PATTERN) {
            control.setOutOfFocusPattern(Pattern.compile(oofRegExpTF.getText()));
        } else if (cv == CheckValue.EMPTY_PATTERN) {
            //allow to save empty pattern
            control.setOutOfFocusPattern(null);
        } else if (cv == CheckValue.REVERT_PATTERN) {
            control.revertOutOfFocusPattern();
        } else if (cv == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            oofRegExpTF.requestFocus();
            return true;
        }
        //fluo patterns are checked when added - nothing to do here
        //frame-pattern
        cv = checkRegexp(frameIdxRegexpTF.getText(), true, "frame number");
        if (cv == CheckValue.VALID_PATTERN) {
            control.setFrameIdxPattern(Pattern.compile(frameIdxRegexpTF.getText()));
        } else if (cv == CheckValue.EMPTY_PATTERN) {
            //allow to save empty pattern
            control.setFrameIdxPattern(null);
        } else if (cv == CheckValue.REVERT_PATTERN) {
            control.revertFrameIdxPattern();
        } else if (cv == CheckValue.EDIT_PATTERN) {
            control.showBatchPanel();
            frameIdxRegexpTF.requestFocus();
            return true;
        }

        //flat field regexp
        boolean cont = ffRegexpChanged();
        if (!cont) {
            return true;
        }
        control.setBatchImageDirectory(new File(imgDirTF.getText()));
        control.setBatchResultsDirectory(new File(resultsDirTF.getText()));
        return false;
    }

    private boolean invalidField(JTextField textField, boolean b, String what, boolean optional) {
        final CheckValue oofCheck = checkRegexp(textField.getText(), b, what);
        if (!optional && oofCheck == CheckValue.EMPTY_PATTERN) {
            JOptionPane.showMessageDialog(this, "Pattern for " + what + " cannot be empty!");
            textField.requestFocus();
            return true;
        } else if (oofCheck == CheckValue.REVERT_PATTERN) {
            return true;
        } else if (oofCheck == CheckValue.EDIT_PATTERN) {
            textField.requestFocus();
            return true;
        }
        return false;
    }

    private void showInfo(String msg, String title) {
        JOptionPane.showMessageDialog(this, msg, title, JOptionPane.INFORMATION_MESSAGE);
    }
    
    
    
}
